use utf8;
use strict;
use warnings FATAL => 'all';

package Xyzzy::Static::Document;

use Xyzzy::Static::Request;

use Xyzzy::Document::XHTML -self;

sub build {
	my $parser = $self->xmlParser;
	my $file = $self->req->file;
	my $xml = $parser->parse_file($file)
		or die "can't parse $file\n";
	$self->xml($xml);
	if(my $sheet = $self->cfg->static_stylesheet) {
		$self->transform($sheet);
	}
}
